package MovementStrategy;

import Directions.Direction;
import DrawningObjects.DrawningMonorail;

public class DrawingObjectMonorail implements IMoveableObject {

    private DrawningMonorail drawingMonorail = null;

    public DrawingObjectMonorail(DrawningMonorail drawingMonorail) {
        this.drawingMonorail = drawingMonorail;
    }

    @Override
    public ObjectParameters getObjectsPosition() {
        if (drawingMonorail == null || drawingMonorail.getEntityMonorail() == null) {
            return null;
        }
        return new ObjectParameters(drawingMonorail.getPosX(), drawingMonorail.getPosY(),
                drawingMonorail.getWidth(), drawingMonorail.getHeight());
    }

    @Override
    public int getStep() {
        if (drawingMonorail == null)
            return 0;
        return (int) ((drawingMonorail.getEntityMonorail() != null) ? 
        drawingMonorail.getEntityMonorail().getStep() : 0);
    }

    @Override
    public boolean checkCanMove(Direction direction) {
        if (drawingMonorail == null)
            return false;
        return drawingMonorail.canMove(direction);
    }

    @Override
    public void moveObject(Direction direction) {
        if (drawingMonorail != null)
            drawingMonorail.moveTransport(direction);
    }
}